# -*- coding: utf-8 -*-
"""
Created on Sun Jan 17 10:23:58 2016

@author: s129520
"""
def inPile(coord, pile):
    return pile[0][0]<=coord[0]<=pile[1][0] and pile[0][1]<=coord[1]<=pile[1][1]
def mean(data, pre=None):
    if not data:
        return 0
    if not pre:
        pre = len(data)
    return sum(data)/float(pre)
def var(data, premean=None, prelen=None):
    if not data:
        return 0
    if not prelen:
        prelen=len(data)
    if not premean:
        premean=mean(data, pre=prelen)
    return sum([(x-premean)**2 for x in data])/float(prelen)
def dev(data, prevar=None, premean=None, prelen=None):
    if not data: 
        return 0
    if prevar:
        return prevar**.5
    if not prelen:
        prelen=len(data)
    if not premean:
        premean = mean(data, pre=prelen)
    return var(data, premean=premean, prelen=prelen)**.5
if __name__=="__main__":
    import os
    import matplotlib as mlp
    import matplotlib.pyplot as plt
    import sys
    sys.path.insert(0,"..")
    ownName= os.path.basename(__file__)
    toBeProcessed = [fileName[:-3] 
      for fileName in os.listdir(".") 
      if fileName!=ownName 
      and fileName[-3:]==".py"]#to double import trough .pyc files
    print toBeProcessed
    dataPerFile = {fileName:__import__(fileName) for fileName in toBeProcessed}
    
    originalSettingsFiles = [__import__(name[:-3]) 
      for name in os.listdir("..")
      if "settings" in name
      and name[-3:]==".py"]#this does make some assumptions
    
    for key in dataPerFile:
        #want to make a total plot of the average size
        currentData= dataPerFile[key].data
        numSimul=len(currentData)
        maxlen = max([len(datum["total size"]) for datum in currentData])
        totalhistory=[[(datum["total size"][i] if i < len(datum["total size"]) else 0) 
                       for datum in currentData]
                      for i in range(maxlen)]
        meanhistory = [mean(h, numSimul) for h in totalhistory]
        plt.plot(meanhistory, label="Mean total size for "+key)
    plt.title("Mean total size")
    plt.xlabel("Time step")
    plt.ylabel("Total size")
    plt.legend(loc=0)
    plt.grid(True)
    plt.savefig("mean total size for "+"-".join(toBeProcessed)+".png", format="png")
    plt.clf()
    #for key in dataPerFile:
    #    #make one large boxplot too
    #    currentData= dataPerFile[key].data
    #    plt.boxplot([len(datum["total size"]) for datum in currentData])
    plt.boxplot([[len(datum["total size"]) for datum in dataPerFile[key].data] for key in dataPerFile],
                  labels=["settings"+str(i) for i in range(1, len(dataPerFile)+1)],
                          meanline=False,
                          showmeans=True)
    plt.title("Duration of simulations")
    plt.savefig("Duration of simulations in "+"-".join(toBeProcessed)+".png", format="png")
    plt.clf()
    
#    for key in dataPerFile:
#        #for every file we want to make the full range of plots
#        #First let's make a combined graph of the total size per simulation
#        currentData= dataPerFile[key].data
#        for datum in currentData:
#            plt.plot(datum["total size"])
#        plt.title("Total size in "+repr(key))
#        plt.xlabel("Time step")
#        plt.ylabel("Total size")
#        plt.grid(True)
#        plt.savefig(key+" - total size.png", format="png")
#        plt.clf()
#        #now make a boxplot of the duration of the simulation
#        #plt.boxplot([len(datum["total size"]) for datum in currentData])
#        #plt.boxplot([(len(datum["total size"]), 
#        #              len([num for num in datum["total victims"] if num!=0]))
#        #              for datum in currentData])
#        plt.boxplot(([len(datum["total size"]) for datum in currentData],
#                     [len([num for num in datum["total victims"] if num!=0])
#                     for datum in currentData]
#                     ),
#                     labels=("Total Duration","Time before everyone is saved"))
#        plt.title("Duration of simulations in "+repr(key))
#        plt.savefig(key+" - duration boxplot.png", format="png")
#        plt.clf()
#        #plot the blackboards
#        #first take just one
#        justOneTry = currentData[0]
#        #differentBBElements = list(set([bbelem["coordinates"] 
#        #  for blackboard in justOneTry["blackboard"] 
#        #  for bbelem in blackboard]))
#        #for coordinates in differentBBElements:
#        #    history=[bbelem["pheromones"]
#        #      for blackboard in justOneTry["blackboard"]
#        #      for bbelem in blackboard
#        #      if bbelem["coordinates"]==coordinates]#maybe want to do this more efficiently
#        #    plt.plot(history)
#        #    break
#        #to do this right, we will need to know what coordinates belong to what pile
#        originalSettings = [settings 
#          for settings in originalSettingsFiles 
#          if settings.name==key][0]
#        actualPiles = [((min(pile[0][0], pile[1][0]),min(pile[0][1], pile[1][1])),
#                        (max(pile[0][0], pile[1][0]),max(pile[0][1], pile[1][1])))
#                        for pile in originalSettings.piles]
#        it=1
#        for actualpile in actualPiles:
#            history = [sum([bbelem["pheromones"] 
#                          for bbelem in blackboard 
#                          if inPile(bbelem["coordinates"], actualpile)]) 
#                      for blackboard in justOneTry["blackboard"]]#summed pheromones 
#                      #of all bbelems belonging to said actualpile
#            plt.plot(history,label="Pile "+str(it))
#            it+=1
#        plt.xlabel("Time step")
#        plt.ylabel("Total pheromone level at pile")
#        plt.title("Pheromones at piles for first simulation")
#        plt.legend(loc=0)
#        plt.grid(True)
#        plt.savefig(key+" - pheromones for first simulation.png", format="png")
#        plt.clf()
#        #before plotting the averaged vies, let's look at how the piles change
#        for i in range(1,len(actualPiles)+1):
#            history = [justOneTry[i][j]["size"] for j in range(len(justOneTry[i]))]
#            plt.plot(history+[0 for l in range(len(justOneTry["total size"])-len(history))], 
#                              label="Pile "+str(i))
#        plt.xlabel("Time step")
#        plt.ylabel("Pile size")
#        plt.title("Pile size for first simulation")
#        plt.legend(loc=0)
#        plt.grid(True)
#        plt.savefig(key+" - pile size for first simulation.png",format="png")
#        plt.clf()
#        
#        #now let's investigate the averaged view
#        numSimul=len(currentData)
#        #for actualpile in actualPiles:
#        #    history = [
#        #      mean([sum([bbelem["pheromones"]
#        #                 for bbelem in simul["blackboard"][i]
#        #                 if inPile(bbelem["coordinates"], actualpile)]) 
#        #           for simul in currentData],
#        #           prelen=numSimul)
#        #      for i in range(len())
#        #I just realized this isn't going to work, so let's forget about it.
#        #but it is for the size :D
#        maxlen = max([len(datum["total size"]) for datum in currentData])
#        totalhistory=[[(datum["total size"][i] if i < len(datum["total size"]) else 0) 
#                       for datum in currentData]
#                      for i in range(maxlen)]
#        meanhistory = [mean(h, numSimul) for h in totalhistory]
#        plt.plot(meanhistory, label="Mean total size")
#        devhistory = [dev(h, prelen=numSimul) for h in totalhistory]
#        plt.plot([meanhistory[i]+devhistory[i] for i in range(maxlen)], label="Mean total size$\, +\, \sigma$")
#        plt.plot([meanhistory[i]-devhistory[i] for i in range(maxlen)], label="Mean total size$\, -\, \sigma$")
#        plt.title("Mean total size")
#        plt.xlabel("Time step")
#        plt.ylabel("Total size")
#        plt.legend(loc=0)
#        plt.grid(True)
#        plt.savefig(key+" - mean total size.png", format="png")
#        plt.clf()
#        #we can now do this foer every pile separately
#        
#        for it in range(1,len(actualPiles)+1):
#            totalhistory=[[(datum[it][i]["size"] if i <len(datum[it]) else 0) 
#                    for datum in currentData] for i in range(maxlen)]
#            meanhistory =[mean(h, numSimul) for h in totalhistory]
#            plt.plot(meanhistory, label="mean size of pile "+str(it))
#            devhistory = [dev(h, prelen=numSimul) for h in totalhistory]
#            plt.plot([meanhistory[i]+devhistory[i] for i in range(maxlen)], label="Mean Size$\, +\, \sigma$")
#            plt.plot([meanhistory[i]-devhistory[i] for i in range(maxlen)], label="Mean Size$\, -\, \sigma$")
#            plt.title("Mean size of pile "+str(it))
#            plt.xlabel("Time step")
#            plt.ylabel("Total size")
#            plt.legend(loc=0)
#            plt.grid(True, which="both")
#            plt.savefig(key+" - mean size at pile "+str(it)+".png", format="png")
#            plt.clf()